Loading...
Searching...
No Matches
CirculationDefaultTraits< GR, LM, UM, SM > Struct Template Reference

## Detailed Description

template<typename GR, typename LM, typename UM, typename SM>
struct lemon::CirculationDefaultTraits< GR, LM, UM, SM >

Default traits class of Circulation class.

Template Parameters

  GR | Type of the digraph the algorithm runs on.
  LM | The type of the lower bound map.
  UM | The type of the upper bound (capacity) map.
  SM | The type of the supply map.

`#include <lemon/circulation.h>`

## Public Types

typedef GR | Digraph
| The type of the digraph the algorithm runs on.
typedef LM | LowerMap
| The type of the lower bound map.
typedef UM | UpperMap
| The type of the upper bound (capacity) map.
typedef SM | SupplyMap
| The type of supply map.
typedef SupplyMap::Value | Value
| The type of the flow and supply values.
typedef GR::ArcMap< Value > | FlowMap
| The type of the map that stores the flow values.
typedef lemon::Elevator< GR, GR::Node > | Elevator
| The elevator type used by the algorithm.
typedef lemon::Tolerance< Value > | Tolerance
| The tolerance used by the algorithm.

## Static Public Member Functions

static FlowMap * | createFlowMap (const Digraph &digraph)
| Instantiates a FlowMap.
static Elevator * | createElevator (const Digraph &digraph, int max_level)
| Instantiates an Elevator.

## Member Typedef Documentation

## LowerMap

template<typename GR, typename LM, typename UM, typename SM>

typedef LM LowerMap

The type of the map that stores the lower bounds on the arcs. It must conform to the ReadMap concept.

## UpperMap

template<typename GR, typename LM, typename UM, typename SM>

typedef UM UpperMap

The type of the map that stores the upper bounds (capacities) on the arcs. It must conform to the ReadMap concept.

## SupplyMap

template<typename GR, typename LM, typename UM, typename SM>

typedef SM SupplyMap

The type of the map that stores the signed supply values of the nodes. It must conform to the ReadMap concept.

## FlowMap

template<typename GR, typename LM, typename UM, typename SM>

typedef GR::ArcMap<Value> FlowMap

The type of the map that stores the flow values. It must conform to the ReadWriteMap concept.

## Elevator

template<typename GR, typename LM, typename UM, typename SM>

typedef lemon::Elevator<GR, GR::Node> Elevator

The elevator type used by the algorithm.

See also
  Elevator, LinkedElevator

## Tolerance

template<typename GR, typename LM, typename UM, typename SM>

typedef lemon::Tolerance<Value> Tolerance

The tolerance used by the algorithm to handle inexact computation.

## Member Function Documentation

## createFlowMap()

template<typename GR, typename LM, typename UM, typename SM>

FlowMap * createFlowMap | ( | const Digraph & | digraph | ) |

inline static

This function instantiates a FlowMap.

Parameters

  digraph | The digraph for which we would like to define the flow map.

## createElevator()

template<typename GR, typename LM, typename UM, typename SM>

Elevator * createElevator | ( | const Digraph & | digraph,
|  | int | max_level )

inline static

This function instantiates an Elevator.

Parameters

  digraph | The digraph for which we would like to define the elevator.
  max_level | The maximum level of the elevator.